enum VPIN {
  //% block="V0"
  V0,
  //% block="V1"
  V1,
  //% block="V2"
  V2,
  //% block="V3"
  V3,
  //% block="V4"
  V4,
  //% block="V5"
  V5,
  //% block="V6"
  V6,
  //% block="V7"
  V7,
  //% block="V8"
  V8,
  //% block="V9"
  V9,
  //% block="V10"
  V10,
  //% block="V11"
  V11,
  //% block="V12"
  V12,
  //% block="V13"
  V13,
  //% block="V14"
  V14,
  //% block="V15"
  V15,
  //% block="V16"
  V16,
  //% block="V17"
  V17,
  //% block="V18"
  V18,
  //% block="V19"
  V19,
  //% block="V20"
  V20,
  //% block="V21"
  V21,
  //% block="V22"
  V22,
  //% block="V23"
  V23,
  //% block="V24"
  V24,
  //% block="V25"
  V25,
  //% block="V26"
  V26,
  //% block="V27"
  V27,
  //% block="V28"
  V28,
  //% block="V29"
  V29,
  //% block="V30"
  V30,
  //% block="V31"
  V31,
  //% block="V32"
  V32,
  //% block="V33"
  V33,
  //% block="V34"
  V34,
  //% block="V35"
  V35,
  //% block="V36"
  V36,
  //% block="V37"
  V37,
  //% block="V38"
  V38,
  //% block="V39"
  V39,
  //% block="V40"
  V40,
  //% block="V41"
  V41,
  //% block="V42"
  V42,
  //% block="V43"
  V43,
  //% block="V44"
  V44,
  //% block="V45"
  V45,
  //% block="V46"
  V46,
  //% block="V47"
  V47,
  //% block="V48"
  V48,
  //% block="V49"
  V49,
  //% block="V50"
  V50,
  //% block="V51"
  V51,
  //% block="V52"
  V52,
  //% block="V53"
  V53,
  //% block="V54"
  V54,
  //% block="V55"
  V55,
  //% block="V56"
  V56,
  //% block="V57"
  V57,
  //% block="V58"
  V58,
  //% block="V59"
  V59,
  //% block="V60"
  V60
}

enum TIMER {
  //% block="1"
  1,
  //% block="2"
  2,
  //% block="3"
  3,
  //% block="4"
  4,
  //% block="5"
  5,
  //% block="6"
  6,
  //% block="7"
  7,
  //% block="8"
  8,
  //% block="9"
  9,
  //% block="10"
  10,
  //% block="11"
  11,
  //% block="12"
  12,
  //% block="13"
  13,
  //% block="14"
  14,
  //% block="15"
  15,
  //% block="16"
  16
}

enum TIME {
  //% block="year"
  year,
  //% block="month"
  month,
  //% block="day"
  day,
  //% block="hour"
  hour,
  //% block="minute"
  minute,
  //% block="second"
  second,
  //% block="weekday"
  weekday
}

enum TYPE {
  //% block="float"
  float,
  //% block="String"
  String
}

enum STATUS {
  //% block="connected"
  connected,
  //% block="disconnected"
  disconnected,
  //% block="appConnected"
  appConnected,
  //% block="appDisconnected"
  appDisconnected
}

enum STATE {
  //% block="HIGH"
  HIGH,
  // block="LOW"
  LOW
}

enum PIN {
  //% block="P0"
  P0,
  //% block="P1"
  P1,
  //% block="P5"
  P5,
  //% block="P6"
  P6,
  //% block="P7"
  P7,
  //% block="P8"
  P8,
  //% block="P9"
  P9,
  //% block="P11"
  P11,
  //% block="P13"
  P13,
  //% block="P14"
  P14,
  //% block="P15"
  P15,
  //% block="P16"
  P16
}

//% color="#30C08D" iconWidth=40 iconHeight=40
namespace blynk {
  // FEATURE: 连接 Wi-Fi
  //% block="connect to Wi-Fi wifi_name [SSID] wifi_pass [PASS]" blockType="command"
  //% SSID.shadow="string" SSID.defl="ssid"
  //% PASS.shadow="string" PASS.defl="password"
  export function connectWiFi(parameter: any, block: any) {
    let ssid = parameter.SSID.code;
    let pass = parameter.PASS.code;
    Generator.addInclude("WiFi", "#include <WiFi.h>");
    Generator.addInclude("WiFiClient", "#include <WiFiClient.h>");
    Generator.addSetup("Serial.begin", `Serial.begin(9600);`);
    Generator.addSetup(
      "Blynk.connectWiFi",
      `Blynk.connectWiFi(${ssid}, ${pass});`
    );
  }

  // FEATURE: Blynk 设置
  //% block="blynk config: blynk_auth [AUTH] blynk_server [SERVER]" blockType="command"
  //% AUTH.shadow="string" AUTH.defl="PUT_YOUR_AUTH_TOKEN_HERE"
  //% SERVER.shadow="string" SERVER.defl="116.62.49.166"
  export function config(parameter: any, block: any) {
    let auth = parameter.AUTH.code;
    let server = parameter.SERVER.code;

    Generator.addInclude("BLYNK_PRINT", "#define BLYNK_PRINT Serial");
    Generator.addInclude(
      "BlynkSimpleEsp32",
      "#include <BlynkSimpleEsp32.h>\n#include <WidgetRTC.h>"
    );

    // 判断服务器地址是域名还是IP类型，生成对应的代码，临时解决方案，有bug
    // 常用服务器地址
    // 116.62.49.166  裘炯涛老师服务器
    // 60.213.28.10   武玉柱老师服务器
    // blynk.mpython.cn  盛思服务器
    // http://blynk-cloud.com
    if (isNaN(server.charAt(2))) {
      Generator.addSetup(
        "Blynk.config",
        `Blynk.config(${auth}, ${server}, 8080);`
      );
    } else {
      server = server.replace(/\"/g, "").replace(/\./g, ",");
      Generator.addSetup(
        "Blynk.config",
        `Blynk.config(${auth}, IPAddress(${server}), 8080);`
      );
    }
  }

  //   // Blynk 初始化
  //   //% block="blynk init: blynk_server [SERVER] wifi_name [SSID] wifi_pass [PASS] blynk_auth [AUTH]" blockType="command"
  //   //% SERVER.shadow="string" SERVER.defl="116.62.49.166"
  //   //% SSID.shadow="string" SSID.defl="Panda@W"
  //   //% PASS.shadow="string" PASS.defl="wcinthehouse"
  //   //% AUTH.shadow="string" AUTH.defl="ZCZFby9mmWJqb0eiZA6nQMHAoSHhD6c_"
  //   export function begin(parameter: any, block: any) {
  //     let server = parameter.SERVER.code;
  //     server = server.replace(/\./g, ",");
  //     server = server.replace(/\"/g, "");
  //     let ssid = parameter.SSID.code;
  //     let pass = parameter.PASS.code;
  //     let auth = parameter.AUTH.code;
  //     Generator.addInclude("BLYNK_PRINT", "#define BLYNK_PRINT Serial");
  //     Generator.addInclude("BlynkSimpleEsp32", "#include <BlynkSimpleEsp32.h>");
  //     // Generator.addInclude('TimeLib', '#include <TimeLib.h>');
  //     Generator.addInclude("WiFi", "#include <WiFi.h>");
  //     Generator.addInclude("WiFiClient", "#include <WiFiClient.h>");
  //     // Generator.addInclude('WidgetsRTC', '#include <WidgetRTC.h>');
  //     Generator.addSetup("Serial.begin", `Serial.begin(9600);`);
  //     Generator.addSetup(
  //       "Blynk.begin",
  //       `Blynk.begin(${auth}, ${ssid}, ${pass}, IPAddress(${server}), 8080);`
  //     );
  //   }

  // FEATURE: Blynk BLE 初始化
  //% block="blynk BLE begin auth [AUTH] name [NAME]" blockType="command"
  //% AUTH.shadow="string" AUTH.defl="PUT_YOUR_AUTH_TOKEN_HERE"
  //% NAME.shadow="string" NAME.defl="Blynk"
  export function bleBegin(parameter: any, block: any) {
    let auth = parameter.AUTH.code;
    let name = parameter.NAME.code;

    Generator.addInclude("BLEDevice", "#include <BLEDevice.h>\n#include <BLEUtils.h>\n#include <BLEScan.h>\n#include <BLEAdvertisedDevice.h>");
    Generator.addInclude("BLEUtils", "");
    Generator.addInclude("BLEScan", "");
    Generator.addInclude("BLEAdvertisedDevice", "");

    Generator.addInclude("BLYNK_PRINT", "#define BLYNK_PRINT Serial");
    Generator.addInclude(
      "BLYNK_USE_DIRECT_CONNECT",
      "#define BLYNK_USE_DIRECT_CONNECT"
    );
    Generator.addInclude(
      "BlynkSimpleEsp32_BLE",
      "#include <BlynkSimpleEsp32_BLE.h>\n#include <WidgetRTC.h>"
    );

    Generator.addSetup("Serial.begin", `Serial.begin(9600);`);
    Generator.addSetup(
      "Serial.println",
      `Serial.println("Waiting for connections...");`
    );
    Generator.addSetup("Blynk.setDeviceName", `Blynk.setDeviceName(${name});`);
    Generator.addSetup("Blynk.begin", `Blynk.begin(${auth});`);
  }

  // FEATURE: 运行 Blynk 进程
  //% block="blynk run" blockType="command"
  export function run(parameter: any, block: any) {
    Generator.addCode("Blynk.run();");
  }

  // FEATURE: 从 App 获取数据
  //% block="get data from blynk app's virtual pin [VPIN]" blockType="hat"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  export function write(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    // Generator.addEvent("functionName", "String", "functionName", "String message, int8_t error", false);
    Generator.addEvent(
      `BLYNK_WRITE_${vpin}`,
      "",
      "BLYNK_WRITE",
      `${vpin}`,
      false
    );
  }

  // FEATURE: 虚拟引脚数据
  //% block="value type [TYPE] No. [NUM]" blockType="reporter"
  //% TYPE.shadow="dropdown" TYPE.options="TYPE" TYPE.defl="TYPE.float"
  //% NUM.shadow="number" NUM.defl=1
  export function vpinValue(parameter: any, block: any) {
    let value_type = parameter.TYPE.code;
    let num = parameter.NUM.code - 1;
    let code = "";
    if (value_type === "float") {
      code = `param[${num}].asFloat()`;
    } else {
      code = `param[${num}].asStr()`;
    }
    Generator.addCode(code);
  }

  // FEATURE: 设置 Blynk 定时器
  //% block="set blynk timer [TIMER] interval [INTERVAL] ms" blockType="hat"
  //% TIMER.shadow="dropdown" TIMER.options="TIMER" TIMER.defl="TIMER.1"
  //% INTERVAL.shadow="number" INTERVAL.defl=1000
  export function timer(parameter: any, block: any) {
    let timer = parameter.TIMER.code;
    let interval = parameter.INTERVAL.code;
    let timerEventName = "myTimerEvent" + timer;
    Generator.addObject(`timer`, `BlynkTimer`, `timer;`);
    Generator.addEvent(
      `${timerEventName}`,
      "void",
      `${timerEventName}`,
      "",
      true
    );
    Generator.addSetup(
      `timer.setInterval${timer}`,
      `timer.setInterval(${interval}L, ${timerEventName});`
    );
  }

  // FEATURE: 运行 Blynk 定时器进程
  //% block="blynk timer run" blockType="command"
  export function timerRun(parameter: any, block: any) {
    Generator.addCode("timer.run();");
  }

  // FEATURE: 发送数据到 App
  //% block="push data [VALUE] to blynk app's virtual pin [VPIN]" blockType="command"
  //% VALUE.shadow="number" VALUE.defl=0
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  export function virtualWrite(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let value = parameter.VALUE.code;
    Generator.addCode(`Blynk.virtualWrite(${vpin}, ${value});`);
  }

  // FEATURE: LED 组件
  //% block="led virtual pin [VPIN] color R [R] G [G] B [B] state [STATE]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  //% R.shadow="number" R.defl=0
  //% G.shadow="number" G.defl=0
  //% B.shadow="number" B.defl=0
  //% STATE.shadow="dropdown" STATE.options="STATE" STATE.defl="STATE.HIGH"
  export function led(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let r = parameter.R.code;
    let g = parameter.G.code;
    let b = parameter.B.code;
    let state = parameter.STATE.code;
    let rh = "";
    let gh = "";
    let bh = "";
    let code = "";

    r = r.toString(16);
    g = g.toString(16);
    b = b.toString(16);

    if (r < 10) {
      rh = "0" + `${r}`;
    } else {
      rh = `${r}`;
    }
    if (g < 10) {
      gh = "0" + `${g}`;
    } else {
      gh = `${g}`;
    }
    if (b < 10) {
      bh = "0" + `${b}`;
    } else {
      bh = `${b}`;
    }

    let color = "#" + rh + gh + bh;
    Generator.addObject(`led_${vpin}`, `WidgetLED`, `led${vpin}(${vpin});`);
    if (state === "HIGH") {
      code = `led${vpin}.setColor("${color}");\n\tled${vpin}.on();`;
    } else {
      code = `led${vpin}.setColor("${color}");\n\tled${vpin}.off();`;
    }
    Generator.addCode(code);
  }

  // FIXME: 发送邮件
  //% block="send email [ADDRESS] [SUBJECT] [CONTENT]" blockType="command"
  //% ADDRESS.shadow="string" ADDRESS.defl="example@blynk.cc"
  //% SUBJECT.shadow="string" SUBJECT.defl="Subject"
  //% CONTENT.shadow="string" CONTENT.defl="Content"
  export function email(parameter: any, block: any) {
    let address = parameter.ADDRESS.code;
    let subject = parameter.SUBJECT.code;
    let content = parameter.CONTENT.code;
    Generator.addInclude(
      "BLYNK_MAX_SENDBYTES",
      "#define BLYNK_MAX_SENDBYTES 128"
    );
    Generator.addCode(`Blynk.email(${address}, ${subject}, ${content});`);
  }

  // FEATURE: 发送通知
  //% block="notify [CONTENT]" blockType="command"
  //% CONTENT.shadow="string" CONTENT.defl="Notify"
  export function notify(parameter: any, block: any) {
    let content = parameter.CONTENT.code;
    Generator.addCode(`Blynk.notify(${content});`);
  }

  // FEATURE: LCD 组件显示
  //% block="lcd display virtual pin [VPIN] row [ROW] column [COLUMN] content [CONTENT]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  //% ROW.shadow="number" ROW.defl=0
  //% COLUMN.shadow="number" COLUMN.defl=0
  //% CONTENT.shadow="string" CONTENT.defl="LCD Display"
  export function lcdDisplay(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let row = parameter.ROW.code;
    let column = parameter.COLUMN.code;
    let content = parameter.CONTENT.code;
    Generator.addObject(`lcd_${vpin}`, `WidgetLCD`, `lcd${vpin}(${vpin});`);
    Generator.addCode(`lcd${vpin}.print(${column}, ${row}, ${content});`);
  }

  // FEATURE: LCD 组件清屏
  //% block="lcd clear virtual pin [VPIN]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  export function lcdClear(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    Generator.addObject(`lcd_${vpin}`, `WidgetLCD`, `lcd${vpin}(${vpin});`);
    Generator.addCode(`lcd${vpin}.clear();`);
  }

  // FEATURE: 视频流
  //% block="video stream [URL] virtual pin [VPIN]" blockType="command"
  //% URL.shadow="string" URL.defl="http://yourvideostream.url"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  export function videoStream(parameter: any, block: any) {
    let url = parameter.URL.code;
    let vpin = parameter.VPIN.code;
    Generator.addCode(`Blynk.setProperty(${vpin}, "url", ${url});`);
  }

  // FEATURE: 硬件已连接、硬件已离线、App已连接、App已离线
  //% block="when blynk status change [STATUS]" blockType="hat"
  //% STATUS.shadow="dropdown" STATUS.options="STATUS" STATUS.defl="STATUS.hardwareConnected"
  export function status(parameter: any, block: any) {
    let status = parameter.STATUS.code;
    if (status === "connected") {
      Generator.addEvent(
        `BLYNK_STATUS_${status}`,
        "",
        "BLYNK_CONNECTED",
        "",
        false
      );
    } else if (status === "disconnected") {
      Generator.addEvent(
        `BLYNK_STATUS_${status}`,
        "",
        "BLYNK_DISCONNECTED",
        "",
        false
      );
    } else if (status === "appConnected") {
      Generator.addEvent(
        `BLYNK_STATUS_${status}`,
        "",
        "BLYNK_APP_CONNECTED",
        "",
        false
      );
    } else {
      Generator.addEvent(
        `BLYNK_STATUS_${status}`,
        "",
        "BLYNK_APP_DISCONNECTED",
        "",
        false
      );
    }
  }

  // FEATURE: RTC 组件时间同步设置
  //% block="RTC begin set sync interval [MINUTE]" blockType="command"
  //% MINUTE.shadow="number" MINUTE.defl=10
  export function rtcBegin(parameter: any, block: any) {
    let minute = parameter.MINUTE.code;
    Generator.addInclude("TimeLib", "#include <TimeLib.h>");
    // Generator.addInclude("WidgetRTC", "#include <WidgetRTC.h>");
    Generator.addObject("rtc", "WidgetRTC", "rtc");
    Generator.addSetup("setSyncInterval", `setSyncInterval(${minute} * 60);`);
    Generator.addCode("rtc.begin();");
  }

  // FEATURE: RTC 组件获取时间
  //% block="RTC time [TIME]" blockType="reporter"
  //% TIME.shadow="dropdown" TIME.options="TIME" TIME.defl="TIME.year"
  export function rtcTime(parameter: any, block: any) {
    let time = parameter.TIME.code;
    let code = "";

    if (time === "year") {
      code = "year()";
    } else if (time === "month") {
      code = "month()";
    } else if (time === "day") {
      code = "day()";
    } else if (time === "hour") {
      code = "hour()";
    } else if (time === "minute") {
      code = "minute()";
    } else if (time === "second") {
      code = "second()";
    } else {
      code = "weekday()";
    }
    Generator.addCode(code);
  }

  // FEATURE: 桥接授权码
  //% block="bridge auth [AUTH] virtual pin [VPIN]" blockType="command"
  //% AUTH.shadow="string" AUTH.defl="PUT_YOUR_BRIDGE_AUTH_TOKEN_HERE"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  export function bridgeAuth(parameter: any, block: any) {
    let auth = parameter.AUTH.code;
    let vpin = parameter.VPIN.code;
    Generator.addObject(
      `bridge_${vpin}`,
      `WidgetBridge`,
      `bridge${vpin}(${vpin});`
    );
    Generator.addCode(`bridge${vpin}.setAuthToken(${auth});`);
  }

  // FEATURE: 桥接虚拟引脚 数字输出
  //% block="bridge virtual pin [VPIN] digital write [PIN] [STATE]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  //% PIN.shadow="dropdown" PIN.options="PIN"
  //% STATE.shadow="dropdown" STATE.options="STATE" STATE.defl="STATE.HIGH"
  export function bridgeDigital(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let pin = parameter.PIN.code;
    let state = parameter.STATE.code;
    Generator.addCode(`bridge${vpin}.digitalWrite(${pin}, ${state});`);
  }

  // FEATURE: 桥接虚拟引脚 模拟输出
  //% block="bridge virtual pin [VPIN] analog write [APIN] [VALUE]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  //% APIN.shadow="dropdown" APIN.options="PIN"
  //% VALUE.shadow="number" VALUE.defl=0
  export function bridgeAnalog(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let apin = parameter.APIN.code;
    let value = parameter.VALUE.code;
    Generator.addCode(`bridge${vpin}.analogWrite(${apin}, ${value});`);
  }

  // FEATURE: 桥接虚拟引脚 虚拟引脚输出
  //% block="bridge virtual pin [VPIN] virtual write [VPIN2] [VALUE]" blockType="command"
  //% VPIN.shadow="dropdown" VPIN.options="VPIN" VPIN.defl="VPIN.V0"
  //% VPIN2.shadow="dropdown" VPIN2.options="VPIN" VPIN2.defl="VPIN.V0"
  //% VALUE.shadow="number" VALUE.defl=0
  export function bridgeVirtual(parameter: any, block: any) {
    let vpin = parameter.VPIN.code;
    let vpin2 = parameter.VPIN2.code;
    let value = parameter.VALUE.code;
    Generator.addCode(`bridge${vpin}.virtualWrite(${vpin2}, ${value});`);
  }

  // FEATURE: 教程地址
  //% block="tutorial [LINK]" blockType="reporter"
  //% LINK.shadow="string" LINK.defl="https://mc.dfrobot.com.cn/thread-303476-1-1.html"
  export function tutorial(parameter: any, block: any) {
    // Generator.addCode("/* tutorial: https://mc.dfrobot.com.cn/thread-303476-1-1.html */");
  }
}
